package com.sun.xml.internal.bind.v2.runtime.unmarshaller;

import java.util.concurrent.Callable;
import org.xml.sax.SAXException;
import javax.xml.bind.ValidationEventHandler;
import java.util.HashMap;
import com.sun.xml.internal.bind.IDResolver;

final class DefaultIDResolver extends IDResolver
{
    private HashMap<String, Object> idmap;
    
    DefaultIDResolver() {
        this.idmap = null;
    }
    
    public void startDocument(ValidationEventHandler eventHandler) throws SAXException {
        if (this.idmap != null) {
            this.idmap.clear();
        }
    }
    
    public void bind(String id, Object obj) {
        if (this.idmap == null) {
            this.idmap = new HashMap();
        }
        this.idmap.put(id, obj);
    }
    
    public Callable resolve(final String id, Class targetType) {
        return new Callable() {
            @Override
            public Object call() throws Exception {
                if (DefaultIDResolver.this.idmap == null) {
                    return null;
                }
                return DefaultIDResolver.this.idmap.get(id);
            }
        };
    }
}
